Index: /trunk/src/gcc/Makefile.in
===================================================================
--- /trunk/src/gcc/Makefile.in	(revision 1109)
+++ /trunk/src/gcc/Makefile.in	(revision 1110)
@@ -8,10 +8,10 @@
 # the Free Software Foundation; either version 2 of the License, or
 # (at your option) any later version.
-# 
+#
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-# 
+#
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
@@ -19,5 +19,5 @@
 #
 
-# Tell GNU make 3.79 not to run the top level in parallel.  This 
+# Tell GNU make 3.79 not to run the top level in parallel.  This
 # prevents contention for $builddir/$target/config.cache, as well
 # as minimizing scatter in file system caches.
@@ -62,5 +62,5 @@
 # Directory in which the compiler finds executables, libraries, etc.
 libsubdir = $(libdir)/gcc-lib/$(target_alias)/$(gcc_version)
-GDB_NLM_DEPS = 
+GDB_NLM_DEPS =
 
 SHELL = /bin/sh
@@ -85,5 +85,5 @@
 # here so that they can be overridden by Makefile fragments.
 HOST_CC = $(CC_FOR_BUILD)
-HOST_PREFIX = 
+HOST_PREFIX =
 HOST_PREFIX_1 = loser-
 
@@ -92,5 +92,5 @@
 CXXFLAGS = -g -O2
 
-LDFLAGS = 
+LDFLAGS =
 LIBCFLAGS = $(CFLAGS)
 CFLAGS_FOR_BUILD = $(CFLAGS)
@@ -100,8 +100,8 @@
 # prepend -O2 when setting CFLAGS_FOR_TARGET.
 CFLAGS_FOR_TARGET = -O2 $(CFLAGS)
-LDFLAGS_FOR_TARGET = 
+LDFLAGS_FOR_TARGET =
 LIBCFLAGS_FOR_TARGET = $(CFLAGS_FOR_TARGET)
-PICFLAG = 
-PICFLAG_FOR_TARGET = 
+PICFLAG =
+PICFLAG_FOR_TARGET =
 
 CXX = c++
@@ -177,5 +177,5 @@
 
 SUBDIRS = "this is set via configure, don't edit this"
-OTHERS = 
+OTHERS =
 
 # This is set by the configure script to the list of directories which
@@ -192,5 +192,5 @@
 # This is set by the configure script to the arguments to use when configuring
 # directories built for the target.
-TARGET_CONFIGARGS = 
+TARGET_CONFIGARGS =
 
 # This is set by the configure script to the arguments to use when configuring
@@ -414,5 +414,5 @@
 	"gcc_version=$(gcc_version)" \
 	"gcc_version_trigger=$(gcc_version_trigger)" \
-	"target_alias=$(target_alias)" 
+	"target_alias=$(target_alias)"
 
 # For any flags above that may contain shell code that varies from one
@@ -511,5 +511,5 @@
 ALL_BUILD_MODULES_LIST = \
 	all-build-libiberty
-ALL_BUILD_MODULES = 
+ALL_BUILD_MODULES =
 
 # This is a list of the configure targets for all of the modules which
@@ -1078,5 +1078,5 @@
 mostlyclean: do-mostlyclean local-clean
 distclean: do-distclean local-clean local-distclean
-maintainer-clean: local-maintainer-clean do-maintainer-clean local-clean 
+maintainer-clean: local-maintainer-clean do-maintainer-clean local-clean
 maintainer-clean: local-distclean
 realclean: maintainer-clean
@@ -1150,6 +1150,6 @@
 
 .PHONY: install install-cross uninstall source-vault binary-vault vault-install
-install: $(INSTALL_TARGET) 
-install-cross: $(INSTALL_TARGET_CROSS) 
+install: $(INSTALL_TARGET)
+install-cross: $(INSTALL_TARGET_CROSS)
 
 uninstall:
@@ -1195,5 +1195,5 @@
 	$(INSTALL_TARGET_MODULES) \
 	$(INSTALL_X11_MODULES) \
-	gcc-no-fixedincludes 
+	gcc-no-fixedincludes
 
 # Install the gcc headers files, but not the fixed include files,
@@ -1662,5 +1662,5 @@
 	else \
 	  true; \
-	fi 
+	fi
 
 .PHONY: install-gcc
@@ -1769,5 +1769,5 @@
 all-build-libiberty: configure-build-libiberty
 
-configure-target-libffi: $(ALL_GCC_C) 
+configure-target-libffi: $(ALL_GCC_C)
 all-target-libffi: configure-target-libffi
 configure-target-libjava: $(ALL_GCC_C) configure-target-zlib configure-target-boehm-gc configure-target-qthreads configure-target-libffi
@@ -1852,5 +1852,5 @@
 dist:
 	@echo "Building a full distribution of this tree isn't done"
-	@echo "via 'make dist'.  Check out the etc/ subdirectory" 
+	@echo "via 'make dist'.  Check out the etc/ subdirectory"
 
 etags tags: TAGS
@@ -2021,5 +2021,6 @@
 
 .PHONY: gas.tar.bz2
-GAS_SUPPORT_DIRS= bfd include libiberty opcodes intl setup.com makefile.vms mkdep
+#GAS_SUPPORT_DIRS= bfd include libiberty opcodes intl setup.com makefile.vms mkdep
+GAS_SUPPORT_DIRS= bfd include libiberty opcodes setup.com makefile.vms mkdep
 gas.tar.bz2: $(DIST_SUPPORT) $(GAS_SUPPORT_DIRS) gas
 	$(MAKE) -f Makefile.in taz TOOL=gas \
@@ -2029,5 +2030,6 @@
 # The FSF "binutils" release includes gprof and ld.
 .PHONY: binutils.tar.bz2
-BINUTILS_SUPPORT_DIRS= bfd gas include libiberty opcodes ld gprof intl setup.com makefile.vms mkdep
+#BINUTILS_SUPPORT_DIRS= bfd gas include libiberty opcodes ld gprof intl setup.com makefile.vms mkdep
+BINUTILS_SUPPORT_DIRS= bfd gas include libiberty opcodes ld gprof setup.com makefile.vms mkdep
 binutils.tar.bz2: $(DIST_SUPPORT) $(BINUTILS_SUPPORT_DIRS) binutils
 	$(MAKE) -f Makefile.in taz TOOL=binutils \
@@ -2049,5 +2051,6 @@
 
 .PHONY: gdb.tar.bz2
-GDB_SUPPORT_DIRS= bfd include libiberty mmalloc opcodes readline sim utils intl
+#GDB_SUPPORT_DIRS= bfd include libiberty mmalloc opcodes readline sim utils intl
+GDB_SUPPORT_DIRS= bfd include libiberty mmalloc opcodes readline sim utils
 gdb.tar.bz2: $(DIST_SUPPORT) $(GDB_SUPPORT_DIRS) gdb
 	$(MAKE) -f Makefile.in gdb-taz TOOL=gdb \