Index: /trunk/src/kmk/kmkbuiltin/cmp.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/cmp.c	(revision 1113)
+++ /trunk/src/kmk/kmkbuiltin/cmp.c	(revision 1113)
@@ -0,0 +1,196 @@
+/*
+ * Copyright (c) 1987, 1990, 1993, 1994
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *	This product includes software developed by the University of
+ *	California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef lint
+static const char copyright[] =
+"@(#) Copyright (c) 1987, 1990, 1993, 1994\n\
+	The Regents of the University of California.  All rights reserved.\n";
+#endif
+
+#if 0
+#ifndef lint
+static char sccsid[] = "@(#)cmp.c	8.3 (Berkeley) 4/2/94";
+#endif
+#endif
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD: src/usr.bin/cmp/cmp.c,v 1.17 2005/08/23 13:13:13 brian Exp $");
+
+#include <sys/types.h>
+#include <sys/stat.h>
+
+#include <err.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+
+#include "extern.h"
+
+int	lflag, sflag, xflag, zflag;
+
+static void usage(void);
+
+int
+main(int argc, char *argv[])
+{
+	struct stat sb1, sb2;
+	off_t skip1, skip2;
+	int ch, fd1, fd2, oflag, special;
+	const char *file1, *file2;
+
+	oflag = O_RDONLY;
+	while ((ch = getopt(argc, argv, "hlsxz")) != -1)
+		switch (ch) {
+		case 'h':		/* Don't follow symlinks */
+			oflag |= O_NOFOLLOW;
+			break;
+		case 'l':		/* print all differences */
+			lflag = 1;
+			break;
+		case 's':		/* silent run */
+			sflag = 1;
+			zflag = 1;
+			break;
+		case 'x':		/* hex output */
+			lflag = 1;
+			xflag = 1;
+			break;
+		case 'z':		/* compare size first */
+			zflag = 1;
+			break;
+		case '?':
+		default:
+			usage();
+		}
+	argv += optind;
+	argc -= optind;
+
+	if (lflag && sflag)
+		errx(ERR_EXIT, "specifying -s with -l or -x is not permitted");
+
+	if (argc < 2 || argc > 4)
+		usage();
+
+	/* Backward compatibility -- handle "-" meaning stdin. */
+	special = 0;
+	if (strcmp(file1 = argv[0], "-") == 0) {
+		special = 1;
+		fd1 = 0;
+		file1 = "stdin";
+	}
+	else if ((fd1 = open(file1, oflag, 0)) < 0 && errno != EMLINK) {
+		if (!sflag)
+			err(ERR_EXIT, "%s", file1);
+		else
+			exit(ERR_EXIT);
+	}
+	if (strcmp(file2 = argv[1], "-") == 0) {
+		if (special)
+			errx(ERR_EXIT,
+				"standard input may only be specified once");
+		special = 1;
+		fd2 = 0;
+		file2 = "stdin";
+	}
+	else if ((fd2 = open(file2, oflag, 0)) < 0 && errno != EMLINK) {
+		if (!sflag)
+			err(ERR_EXIT, "%s", file2);
+		else
+			exit(ERR_EXIT);
+	}
+
+	skip1 = argc > 2 ? strtol(argv[2], NULL, 0) : 0;
+	skip2 = argc == 4 ? strtol(argv[3], NULL, 0) : 0;
+
+	if (fd1 == -1) {
+		if (fd2 == -1) {
+			c_link(file1, skip1, file2, skip2);
+			exit(0);
+		} else if (!sflag)
+			errx(ERR_EXIT, "%s: Not a symbolic link", file2);
+		else
+			exit(ERR_EXIT);
+	} else if (fd2 == -1) {
+		if (!sflag)
+			errx(ERR_EXIT, "%s: Not a symbolic link", file1);
+		else
+			exit(ERR_EXIT);
+	}
+
+	if (!special) {
+		if (fstat(fd1, &sb1)) {
+			if (!sflag)
+				err(ERR_EXIT, "%s", file1);
+			else
+				exit(ERR_EXIT);
+		}
+		if (!S_ISREG(sb1.st_mode))
+			special = 1;
+		else {
+			if (fstat(fd2, &sb2)) {
+				if (!sflag)
+					err(ERR_EXIT, "%s", file2);
+				else
+					exit(ERR_EXIT);
+			}
+			if (!S_ISREG(sb2.st_mode))
+				special = 1;
+		}
+	}
+
+	if (special)
+		c_special(fd1, file1, skip1, fd2, file2, skip2);
+	else {
+		if (zflag && sb1.st_size != sb2.st_size) {
+			if (!sflag)
+				(void) printf("%s %s differ: size\n",
+				    file1, file2);
+			exit(DIFF_EXIT);
+		}
+		c_regular(fd1, file1, skip1, sb1.st_size,
+		    fd2, file2, skip2, sb2.st_size);
+	}
+	exit(0);
+}
+
+static void
+usage(void)
+{
+
+	(void)fprintf(stderr,
+	    "usage: cmp [-l | -s | -x] [-hz] file1 file2 [skip1 [skip2]]\n");
+	exit(ERR_EXIT);
+}
Index: /trunk/src/kmk/kmkbuiltin/cmp_extern.h
===================================================================
--- /trunk/src/kmk/kmkbuiltin/cmp_extern.h	(revision 1113)
+++ /trunk/src/kmk/kmkbuiltin/cmp_extern.h	(revision 1113)
@@ -0,0 +1,49 @@
+/*-
+ * Copyright (c) 1991, 1993, 1994
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *	This product includes software developed by the University of
+ *	California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *	@(#)extern.h	8.3 (Berkeley) 4/2/94
+ *
+ * $FreeBSD: src/usr.bin/cmp/extern.h,v 1.5 2005/08/23 13:13:13 brian Exp $
+ *
+ */
+
+#define OK_EXIT		0
+#define DIFF_EXIT	1
+#define ERR_EXIT	2	/* error exit code */
+
+void	c_link(const char *, off_t, const char *, off_t);
+void	c_regular(int, const char *, off_t, off_t, int, const char *, off_t, off_t);
+void	c_special(int, const char *, off_t, int, const char *, off_t);
+void	diffmsg(const char *, const char *, off_t, off_t);
+void	eofmsg(const char *);
+
+extern int lflag, sflag, xflag;
Index: /trunk/src/kmk/kmkbuiltin/cmp_misc.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/cmp_misc.c	(revision 1113)
+++ /trunk/src/kmk/kmkbuiltin/cmp_misc.c	(revision 1113)
@@ -0,0 +1,66 @@
+/*-
+ * Copyright (c) 1991, 1993, 1994
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *	This product includes software developed by the University of
+ *	California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#if 0
+#ifndef lint
+static char sccsid[] = "@(#)misc.c	8.3 (Berkeley) 4/2/94";
+#endif
+#endif
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD: src/usr.bin/cmp/misc.c,v 1.7 2002/07/28 15:13:17 dwmalone Exp $");
+
+#include <sys/types.h>
+
+#include <err.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+#include "extern.h"
+
+void
+eofmsg(const char *file)
+{
+	if (!sflag)
+		warnx("EOF on %s", file);
+	exit(DIFF_EXIT);
+}
+
+void
+diffmsg(const char *file1, const char *file2, off_t byte, off_t line)
+{
+	if (!sflag)
+		(void)printf("%s %s differ: char %lld, line %lld\n",
+		    file1, file2, (long long)byte, (long long)line);
+	exit(DIFF_EXIT);
+}
Index: /trunk/src/kmk/kmkbuiltin/cmp_regular.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/cmp_regular.c	(revision 1113)
+++ /trunk/src/kmk/kmkbuiltin/cmp_regular.c	(revision 1113)
@@ -0,0 +1,178 @@
+/*-
+ * Copyright (c) 1991, 1993, 1994
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *	This product includes software developed by the University of
+ *	California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#if 0
+#ifndef lint
+static char sccsid[] = "@(#)regular.c	8.3 (Berkeley) 4/2/94";
+#endif
+#endif
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD: src/usr.bin/cmp/regular.c,v 1.18 2003/02/26 06:44:46 das Exp $");
+
+#include <sys/param.h>
+#include <sys/mman.h>
+#include <sys/stat.h>
+
+#include <err.h>
+#include <errno.h>
+#include <limits.h>
+#include <signal.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+#include <unistd.h>
+
+#include "extern.h"
+
+static u_char *remmap(u_char *, int, off_t);
+static void segv_handler(int);
+#define MMAP_CHUNK (8*1024*1024)
+
+#define ROUNDPAGE(i) ((i) & ~pagemask)
+
+void
+c_regular(int fd1, const char *file1, off_t skip1, off_t len1,
+    int fd2, const char *file2, off_t skip2, off_t len2)
+{
+	u_char ch, *p1, *p2, *m1, *m2, *e1, *e2;
+	off_t byte, length, line;
+	int dfound;
+	off_t pagemask, off1, off2;
+	size_t pagesize;
+	struct sigaction act, oact;
+
+	if (skip1 > len1)
+		eofmsg(file1);
+	len1 -= skip1;
+	if (skip2 > len2)
+		eofmsg(file2);
+	len2 -= skip2;
+
+	if (sflag && len1 != len2)
+		exit(DIFF_EXIT);
+
+	sigemptyset(&act.sa_mask);
+	act.sa_flags = SA_NODEFER;
+	act.sa_handler = segv_handler;
+	if (sigaction(SIGSEGV, &act, &oact))
+		err(ERR_EXIT, "sigaction()");
+
+	pagesize = getpagesize();
+	pagemask = (off_t)pagesize - 1;
+	off1 = ROUNDPAGE(skip1);
+	off2 = ROUNDPAGE(skip2);
+
+	length = MIN(len1, len2);
+
+	if ((m1 = remmap(NULL, fd1, off1)) == NULL) {
+		c_special(fd1, file1, skip1, fd2, file2, skip2);
+		return;
+	}
+
+	if ((m2 = remmap(NULL, fd2, off2)) == NULL) {
+		munmap(m1, MMAP_CHUNK);
+		c_special(fd1, file1, skip1, fd2, file2, skip2);
+		return;
+	}
+
+	dfound = 0;
+	e1 = m1 + MMAP_CHUNK;
+	e2 = m2 + MMAP_CHUNK;
+	p1 = m1 + (skip1 - off1);
+	p2 = m2 + (skip2 - off2);
+
+	for (byte = line = 1; length--; ++byte) {
+		if ((ch = *p1) != *p2) {
+			if (xflag) {
+				dfound = 1;
+				(void)printf("%08llx %02x %02x\n",
+				    (long long)byte - 1, ch, *p2);
+			} else if (lflag) {
+				dfound = 1;
+				(void)printf("%6lld %3o %3o\n",
+				    (long long)byte, ch, *p2);
+			} else
+				diffmsg(file1, file2, byte, line);
+				/* NOTREACHED */
+		}
+		if (ch == '\n')
+			++line;
+		if (++p1 == e1) {
+			off1 += MMAP_CHUNK;
+			if ((p1 = m1 = remmap(m1, fd1, off1)) == NULL) {
+				munmap(m2, MMAP_CHUNK);
+				err(ERR_EXIT, "remmap %s", file1);
+			}
+			e1 = m1 + MMAP_CHUNK;
+		}
+		if (++p2 == e2) {
+			off2 += MMAP_CHUNK;
+			if ((p2 = m2 = remmap(m2, fd2, off2)) == NULL) {
+				munmap(m1, MMAP_CHUNK);
+				err(ERR_EXIT, "remmap %s", file2);
+			}
+			e2 = m2 + MMAP_CHUNK;
+		}
+	}
+	munmap(m1, MMAP_CHUNK);
+	munmap(m2, MMAP_CHUNK);
+
+	if (sigaction(SIGSEGV, &oact, NULL))
+		err(ERR_EXIT, "sigaction()");
+
+	if (len1 != len2)
+		eofmsg (len1 > len2 ? file2 : file1);
+	if (dfound)
+		exit(DIFF_EXIT);
+}
+
+static u_char *
+remmap(u_char *mem, int fd, off_t offset)
+{
+	if (mem != NULL)
+		munmap(mem, MMAP_CHUNK);
+	mem = mmap(NULL, MMAP_CHUNK, PROT_READ, MAP_SHARED, fd, offset);
+	if (mem == MAP_FAILED)
+		return (NULL);
+	madvise(mem, MMAP_CHUNK, MADV_SEQUENTIAL);
+	return (mem);
+}
+
+static void
+segv_handler(int sig) {
+	static const char msg[] = "cmp: Input/output error (caught SIGSEGV)\n";
+
+	write(STDERR_FILENO, msg, sizeof(msg));
+	_exit(EXIT_FAILURE);
+}
Index: /trunk/src/kmk/kmkbuiltin/cmp_special.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/cmp_special.c	(revision 1113)
+++ /trunk/src/kmk/kmkbuiltin/cmp_special.c	(revision 1113)
@@ -0,0 +1,109 @@
+/*-
+ * Copyright (c) 1991, 1993, 1994
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *	This product includes software developed by the University of
+ *	California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#if 0
+#ifndef lint
+static char sccsid[] = "@(#)special.c	8.3 (Berkeley) 4/2/94";
+#endif
+#endif
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD: src/usr.bin/cmp/special.c,v 1.10 2003/06/19 07:24:26 murray Exp $");
+
+#include <sys/types.h>
+
+#include <err.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+
+#include "extern.h"
+
+void
+c_special(int fd1, const char *file1, off_t skip1,
+    int fd2, const char *file2, off_t skip2)
+{
+	int ch1, ch2;
+	off_t byte, line;
+	FILE *fp1, *fp2;
+	int dfound;
+
+	if ((fp1 = fdopen(fd1, "r")) == NULL)
+		err(ERR_EXIT, "%s", file1);
+	if ((fp2 = fdopen(fd2, "r")) == NULL)
+		err(ERR_EXIT, "%s", file2);
+
+	dfound = 0;
+	while (skip1--)
+		if (getc(fp1) == EOF)
+			goto eof;
+	while (skip2--)
+		if (getc(fp2) == EOF)
+			goto eof;
+
+	for (byte = line = 1;; ++byte) {
+		ch1 = getc(fp1);
+		ch2 = getc(fp2);
+		if (ch1 == EOF || ch2 == EOF)
+			break;
+		if (ch1 != ch2) {
+			if (xflag) {
+				dfound = 1;
+				(void)printf("%08llx %02x %02x\n",
+				    (long long)byte - 1, ch1, ch2);
+			} else if (lflag) {
+				dfound = 1;
+				(void)printf("%6lld %3o %3o\n",
+				    (long long)byte, ch1, ch2);
+			} else {
+				diffmsg(file1, file2, byte, line);
+				/* NOTREACHED */
+			}
+		}
+		if (ch1 == '\n')
+			++line;
+	}
+
+eof:	if (ferror(fp1))
+		err(ERR_EXIT, "%s", file1);
+	if (ferror(fp2))
+		err(ERR_EXIT, "%s", file2);
+	if (feof(fp1)) {
+		if (!feof(fp2))
+			eofmsg(file1);
+	} else
+		if (feof(fp2))
+			eofmsg(file2);
+	if (dfound)
+		exit(DIFF_EXIT);
+}