Index: /trunk/src/binutils/bfd/po/Make-in
===================================================================
--- /trunk/src/binutils/bfd/po/Make-in	(revision 1117)
+++ /trunk/src/binutils/bfd/po/Make-in	(revision 1118)
@@ -31,8 +31,8 @@
 CC = @CC@
 GENCAT = @GENCAT@
-GMSGFMT = PATH=../src:$$PATH @GMSGFMT@
+GMSGFMT = PATH="../src@PATH_SEPARATOR@$$PATH" @GMSGFMT@
 MSGFMT = @MSGFMT@
-XGETTEXT = PATH=../src:$$PATH @XGETTEXT@
-MSGMERGE = PATH=../src:$$PATH msgmerge
+XGETTEXT = PATH="../src@PATH_SEPARATOR@$$PATH" @XGETTEXT@
+MSGMERGE = PATH="../src@PATH_SEPARATOR@$$PATH" msgmerge
 
 DEFS = @DEFS@
@@ -93,5 +93,5 @@
 	  --directory=$(top_srcdir) \
 	  --add-comments --keyword=_ --keyword=N_ \
-	  --files-from=$(srcdir)/SRC-POTFILES.in 
+	  --files-from=$(srcdir)/SRC-POTFILES.in
 	$(XGETTEXT) --default-domain=$(PACKAGE) \
 	  --directory=.. \
@@ -206,5 +206,5 @@
 distclean: clean
 	rm -f Makefile Makefile.in *.mo *.msg *.cat *.cat.m
-	rm -f SRC-POTFILES BLD-POTFILES 
+	rm -f SRC-POTFILES BLD-POTFILES
 
 maintainer-clean: distclean
@@ -223,5 +223,5 @@
 update-po: Makefile
 	$(MAKE) $(PACKAGE).pot
-	PATH=`pwd`/../src:$$PATH; \
+	PATH="`pwd`/../src@PATH_SEPARATOR@$$PATH"; \
 	cd $(srcdir); \
 	catalogs='$(CATALOGS)'; \
Index: /trunk/src/binutils/binutils/po/Make-in
===================================================================
--- /trunk/src/binutils/binutils/po/Make-in	(revision 1117)
+++ /trunk/src/binutils/binutils/po/Make-in	(revision 1118)
@@ -31,8 +31,8 @@
 CC = @CC@
 GENCAT = @GENCAT@
-GMSGFMT = PATH=../src:$$PATH @GMSGFMT@
+GMSGFMT = PATH="../src@PATH_SEPARATOR@$$PATH" @GMSGFMT@
 MSGFMT = @MSGFMT@
-XGETTEXT = PATH=../src:$$PATH @XGETTEXT@
-MSGMERGE = PATH=../src:$$PATH msgmerge
+XGETTEXT = PATH="../src@PATH_SEPARATOR@$$PATH" @XGETTEXT@
+MSGMERGE = PATH="../src@PATH_SEPARATOR@$$PATH" msgmerge
 
 DEFS = @DEFS@
@@ -209,5 +209,5 @@
 update-po: Makefile
 	$(MAKE) $(PACKAGE).pot
-	PATH=`pwd`/../src:$$PATH; \
+	PATH="`pwd`/../src@PATH_SEPARATOR@$$PATH"; \
 	cd $(srcdir); \
 	catalogs='$(CATALOGS)'; \
Index: /trunk/src/binutils/gas/po/Make-in
===================================================================
--- /trunk/src/binutils/gas/po/Make-in	(revision 1117)
+++ /trunk/src/binutils/gas/po/Make-in	(revision 1118)
@@ -31,8 +31,8 @@
 CC = @CC@
 GENCAT = @GENCAT@
-GMSGFMT = PATH=../src:$$PATH @GMSGFMT@
+GMSGFMT = PATH="../src@PATH_SEPARATOR@$$PATH" @GMSGFMT@
 MSGFMT = @MSGFMT@
-XGETTEXT = PATH=../src:$$PATH @XGETTEXT@
-MSGMERGE = PATH=../src:$$PATH msgmerge
+XGETTEXT = PATH="../src@PATH_SEPARATOR@$$PATH" @XGETTEXT@
+MSGMERGE = PATH="../src@PATH_SEPARATOR@$$PATH" msgmerge
 
 DEFS = @DEFS@
@@ -209,5 +209,5 @@
 update-po: Makefile
 	$(MAKE) $(PACKAGE).pot
-	PATH=`pwd`/../src:$$PATH; \
+	PATH="`pwd`/../src@PATH_SEPARATOR@$$PATH"; \
 	cd $(srcdir); \
 	catalogs='$(CATALOGS)'; \
Index: /trunk/src/binutils/gprof/po/Make-in
===================================================================
--- /trunk/src/binutils/gprof/po/Make-in	(revision 1117)
+++ /trunk/src/binutils/gprof/po/Make-in	(revision 1118)
@@ -31,8 +31,8 @@
 CC = @CC@
 GENCAT = @GENCAT@
-GMSGFMT = PATH=../src:$$PATH @GMSGFMT@
+GMSGFMT = PATH="../src@PATH_SEPARATOR@$$PATH" @GMSGFMT@
 MSGFMT = @MSGFMT@
-XGETTEXT = PATH=../src:$$PATH @XGETTEXT@
-MSGMERGE = PATH=../src:$$PATH msgmerge
+XGETTEXT = PATH="../src@PATH_SEPARATOR@$$PATH" @XGETTEXT@
+MSGMERGE = PATH="../src@PATH_SEPARATOR@$$PATH" msgmerge
 
 DEFS = @DEFS@
@@ -211,5 +211,5 @@
 update-po: Makefile
 	$(MAKE) $(PACKAGE).pot
-	PATH=`pwd`/../src:$$PATH; \
+	PATH="`pwd`/../src@PATH_SEPARATOR@$$PATH"; \
 	cd $(srcdir); \
 	catalogs='$(CATALOGS)'; \
Index: /trunk/src/binutils/ld/po/Make-in
===================================================================
--- /trunk/src/binutils/ld/po/Make-in	(revision 1117)
+++ /trunk/src/binutils/ld/po/Make-in	(revision 1118)
@@ -31,8 +31,8 @@
 CC = @CC@
 GENCAT = @GENCAT@
-GMSGFMT = PATH=../src:$$PATH @GMSGFMT@
+GMSGFMT = PATH="../src@PATH_SEPARATOR@$$PATH" @GMSGFMT@
 MSGFMT = @MSGFMT@
-XGETTEXT = PATH=../src:$$PATH @XGETTEXT@
-MSGMERGE = PATH=../src:$$PATH msgmerge
+XGETTEXT = PATH="../src@PATH_SEPARATOR@$$PATH" @XGETTEXT@
+MSGMERGE = PATH="../src@PATH_SEPARATOR@$$PATH" msgmerge
 
 DEFS = @DEFS@
@@ -209,5 +209,5 @@
 update-po: Makefile
 	$(MAKE) $(PACKAGE).pot
-	PATH=`pwd`/../src:$$PATH; \
+	PATH="`pwd`/../src@PATH_SEPARATOR@$$PATH"; \
 	cd $(srcdir); \
 	catalogs='$(CATALOGS)'; \
Index: /trunk/src/binutils/opcodes/po/Make-in
===================================================================
--- /trunk/src/binutils/opcodes/po/Make-in	(revision 1117)
+++ /trunk/src/binutils/opcodes/po/Make-in	(revision 1118)
@@ -31,8 +31,8 @@
 CC = @CC@
 GENCAT = @GENCAT@
-GMSGFMT = PATH=../src:$$PATH @GMSGFMT@
+GMSGFMT = PATH="../src@PATH_SEPARATOR@$$PATH" @GMSGFMT@
 MSGFMT = @MSGFMT@
-XGETTEXT = PATH=../src:$$PATH @XGETTEXT@
-MSGMERGE = PATH=../src:$$PATH msgmerge
+XGETTEXT = PATH="../src@PATH_SEPARATOR@$$PATH" @XGETTEXT@
+MSGMERGE = PATH="../src@PATH_SEPARATOR@$$PATH" msgmerge
 
 DEFS = @DEFS@
@@ -209,5 +209,5 @@
 update-po: Makefile
 	$(MAKE) $(PACKAGE).pot
-	PATH=`pwd`/../src:$$PATH; \
+	PATH="`pwd`/../src@PATH_SEPARATOR@$$PATH"; \
 	cd $(srcdir); \
 	catalogs='$(CATALOGS)'; \