Index: /trunk/Makefile
===================================================================
--- /trunk/Makefile	(revision 1126)
+++ /trunk/Makefile	(revision 1127)
@@ -137,7 +137,7 @@
 		\
 		all-symlinks-unlink
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ Make Ended Successfully: $(shell date)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 
 #
@@ -146,57 +146,57 @@
 		
 all-banner-start:
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ Make started: $(shell date)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 		
 all-banner-stage1:
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ Stage 1 - starting: $(shell date)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 
 all-banner-stage2:
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ Stage 2 - starting: $(shell date)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	
 all-banner-builttools-initial:
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ Initializing builttools tree"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 		
 all-banner-builttools-stage2:
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ Copying stage2 builttools"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 
 all-banner-install:
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ Install - starting: $(shell date)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	
 all-banner-install-done:
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ Install - done: $(shell date)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 
 all-banner-symlinks-start:
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ symlinks - staring: $(shell date)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 		
 all-banner-symlinks-done:
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ symlinks - done: $(shell date)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 
 all-banner-symlinks-unlink-start:
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ symlinks unlinking - staring: $(shell date)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 		
 all-banner-symlinks-unlink-done:
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ symlinks unlinking - done: $(shell date)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 								
 		
@@ -206,5 +206,5 @@
 	
 all-env:	
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "Variables:"
 	@echo "    PWD                  = $(PWD)"
@@ -260,11 +260,11 @@
 	@echo "    OBJC_INCLUDE_PATH    = $(OBJC_INCLUDE_PATH)"
 	@echo "    LIBRARY_PATH         = $(LIBRARY_PATH)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "Content of PATH_OBJ:"
 	-ls -la $(PATH_OBJ)/
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "Content of PATH_BIN:"
 	-ls -la $(PATH_BIN)/
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	
 	
@@ -352,7 +352,7 @@
 	echo "$(@F)" > $(PATH_OBJ)/.last-stage
 	touch $@
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ Stage 1 - done: $(shell date)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 
 all-stage1-it: \
@@ -370,12 +370,12 @@
 	echo "$(@F)" > $(PATH_OBJ)/.last-stage
 	touch $@
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ Stage 2 - done: $(shell date)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 
 $(PATH_OBJ)/.all-stage2.save-stage1:
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ Saving Stage 1 - Starting: $(shell date)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	$(MAKE) $(MAKEOPT) -j 1 -f $(MAKEFILE) all-preload-unload
 	$(MAKE) $(MAKEOPT) -j 1 -f $(MAKEFILE) all-builttools-stage2
@@ -387,7 +387,7 @@
 	$(MAKE) $(MAKEOPT) -j 1 -f $(MAKEFILE) all-preload
 	touch $@
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	@echo "+ Saving Stage 1 - done: $(shell date)"
-	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
 	
 all-stage2-it: \
@@ -417,8 +417,126 @@
 	emx-diff \
 	
-	
-	
-	
-	
+										
+	
+	
+
+###############################################################################
+###############################################################################
+###############################################################################
+#
+#    Q u i c k   b o o t s t r a p p i n g
+#
+###############################################################################
+###############################################################################
+###############################################################################
+
+
+quick all-quick:
+	mkdir -p $(PATH_OBJ)
+	$(NICE) $(MAKE) $(MAKEOPT) -j 1 -C . all-quick-logged 2>&1 | $(UNIXROOT)/usr/bin/tee $(PATH_OBJ)/build-`date +"%Y%m%d-%H%M%S"`.log
+
+all-quick-banner-start:
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "+ Quick Bootstrap started:            $(shell date)"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+all-quick-logged: \
+        all-quick-banner-start \
+		all-env \
+		all-sanity \
+		all-preload \
+		all-versionstamps \
+		all-symlinks-unlink \
+		\
+		all-quick-stage1 \
+		all-quick-stage2 \
+		all-quick-stage3 \
+		all-quick-stage4 \
+		\
+		all-quick-install
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "+ Quick Bootstrap Ended Successfully: $(shell date)"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+
+# stage 1 builds the base libraries.	
+all-quick-stage1: $(PATH_OBJ)/.quick-stage1
+all-quick-stage1-it: \
+		all-preload-unload \
+		all-builttools-initial \
+		all-preload \
+        emx-quick-libs \
+		all-preload-unload \
+		emx-quick-libs-install \
+		all-preload
+$(PATH_OBJ)/.quick-stage1:
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "+ Quick Bootstrap Stage 1 - starting: $(shell date)"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+	$(MAKE) $(MAKEOPT) -f $(MAKEFILE) all-quick-stage1-it
+	echo "$(@F)" > $(PATH_OBJ)/.quick-last-stage
+	touch $@
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "+ Quick Bootstrap Stage 1 - done:     $(shell date)"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+
+# stage 2 builds the emx base utilities.
+all-quick-stage2: $(PATH_OBJ)/.quick-stage2
+all-quick-stage2-it: \
+        emx-quick-rest \
+		all-preload-unload \
+		emx-quick-rest-install \
+		all-preload
+$(PATH_OBJ)/.quick-stage2:
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "+ Quick Bootstrap Stage 2 - starting: $(shell date)"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+	$(MAKE) $(MAKEOPT) -f $(MAKEFILE) all-quick-stage2-it
+	echo "$(@F)" > $(PATH_OBJ)/.quick-last-stage
+	touch $@
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "+ Quick Bootstrap Stage 2 - done:     $(shell date)"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+
+# stage 3 builds all the binutil utilities and libraries.
+all-quick-stage3: $(PATH_OBJ)/.quick-stage3
+all-quick-stage3-it: \
+        binutils-quick \
+		all-preload-unload \
+		binutils-quick-installstage \
+		all-preload
+$(PATH_OBJ)/.quick-stage3:
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "+ Quick Bootstrap Stage 3 - starting: $(shell date)"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+	$(MAKE) $(MAKEOPT) -f $(MAKEFILE) all-quick-stage3-it
+	echo "$(@F)" > $(PATH_OBJ)/.quick-last-stage
+	touch $@
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "+ Quick Bootstrap Stage 3 - done:     $(shell date)"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+
+# stage 4 builds gcc.
+all-quick-stage4: $(PATH_OBJ)/.quick-stage4
+all-quick-stage4-it: \
+        gcc-quick \
+		all-preload-unload \
+		gcc-quick-installstage \
+		all-preload
+$(PATH_OBJ)/.quick-stage4:
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "+ Quick Bootstrap Stage 4 - starting: $(shell date)"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+	$(MAKE) $(MAKEOPT) -f $(MAKEFILE) all-quick-stage4-it
+	echo "$(@F)" > $(PATH_OBJ)/.quick-last-stage
+	touch $@
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+	@echo "+ Quick Bootstrap Stage 4 - done:     $(shell date)"
+	@echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
+
+
+# Installs the stuff we've built.			
+all-quick-install:
+	echo todo
+	
+
 	
 ###############################################################################
@@ -660,5 +778,5 @@
 all-gcc       gcc:	\
         gcc-autoconf-refresh \
-        gcc-build
+        gcc-bootstrap
 	echo "Successfully build GCC."
 
@@ -713,6 +831,6 @@
 	
 # build the components.
-.PHONY: gcc-build gcc-install gcc-configure
-gcc-build gcc-install gcc-configure:
+.PHONY: gcc-bootstrap gcc-build gcc-install gcc-configure
+gcc-bootstrap gcc-build gcc-install gcc-configure:
 	mkdir -p $(PATH_OBJ)/gcc
 	$(MAKE) $(MAKEOPT) -j 1 -C $(PATH_OBJ)/gcc -f $(MAKEFILE) $@-it
@@ -728,5 +846,5 @@
 #              -specs $(PATH_TOP)/tools/x86.os2/gcc/staged/lib/gcc-lib/i386-pc-os2-emx/$(GCC_VERSION)/specs)
 SPECS_HACK =
-gcc-build-it: \
+gcc-bootstrap-it gcc-build-it: \
 		$(PATH_OBJ)/gcc/.ts.configured
 ifeq "$(BUILD_PLATFORM)" "OS2"		
@@ -738,7 +856,7 @@
 		     LDFLAGS="$(SPEC_HACK) $(BUILD_DEBUGINFO) -Zhigh-mem -Zcrtdll -Zstack 1024 -Zomf" \
 		BOOT_LDFLAGS="$(SPEC_HACK) $(BUILD_DEBUGINFO) -Zhigh-mem -Zcrtdll -Zstack 1024 -Zomf" \
-		bootstrap
+		$(subst build, all, $(patsubst gcc-%-it, %, $@))
 else
-	$(MAKE) $(MAKEOPT) -C $(PATH_OBJ)/gcc bootstrap
+	$(MAKE) $(MAKEOPT) -C $(PATH_OBJ)/gcc $(subst build, all, $(patsubst gcc-%-it, %, $@))
 endif	
 		
@@ -802,4 +920,15 @@
 ##	cp $(PATH_TOP)/src/emx/src/lib/libc.specs $(PATH_OBJ)/gcc/gcc/specs
 
+
+# Quick bootstrap workers.
+gcc-quick:  \
+	gcc-autoconf-refresh \
+	gcc-build
+	
+gcc-quick-installstage:
+	rm -Rf $(PATH_BUILTTOOLS_TMP)
+	$(MAKE) $(MAKEOPT) -C $(PATH_OBJ)/gcc prefix=$(PATH_BUILTTOOLS_TMPD) install
+	cp -Rf $(PATH_BUILTTOOLS_TMP)/* $(PATH_BUILTTOOLS)/
+
 		
 # Generate diffs for GCC (v3.2.2) - part of packing a release.
@@ -809,118 +938,4 @@
 	mkdir -p $(@D)
 	$(TOOL_CVS_DIFF_TREE) $(GCC_CVS_REL) src/gcc > $@
-
-		
-		
-##############################################################################
-###############################################################################
-###############################################################################
-#
-#    G C C   -   O M F   f o r   D e B u G i n g
-#
-###############################################################################
-###############################################################################
-###############################################################################
-all-gccomf: gccomf
-gccomf:
-	mkdir -p $(PATH_OBJ)/gccomf
-	$(NICE) $(MAKE) $(MAKEOPT) -C . gccomf-logged 2>&1 | $(UNIXROOT)/usr/bin/tee $(PATH_OBJ)/gccomf/build-`date +"%Y%m%d-%H%M%S"`.log
-					
-gccomf-logged: \
-		gcc-autoconf-refresh \
-        gccomf-build
-	echo "Unbelievable!!! We just successfully completed a GCC OMF build!!!"
-
-# build the components.
-.PHONY: gccomf-build gccomf-install gccomf-configure
-gccomf-build gccomf-install gccomf-configure:
-	mkdir -p $(PATH_OBJ)/gccomf
-	$(MAKE) $(MAKEOPT) -C $(PATH_OBJ)/gccomf -f $(MAKEFILE) $@-it
-
-
-# Separate since we want the 'e' option
-gccomf-shell:		   	
-	mkdir -p $(PATH_OBJ)/gccomf
-	$(MAKE) $(MAKEOPT) -e -C $(PATH_OBJ)/gccomf -f $(MAKEFILE) $@-it
-gccomf-shell-it:
-	chdir $(PATH_OBJ)/gccomf ; \
-		if test -d $(PATH_BUILTTOOLS)/omfhack; then mv -f $(PATH_BUILTTOOLS)/omfhack $(PATH_BUILTTOOLS)/omfhackbin; fi ; \
-		if test ! -d $(PATH_BUILTTOOLS)/omfhackbin; then echo "no omfhackbin"; exit 1; fi ; \
-		unset GCCLOAD; \
-		export GCC_OMF="real"; \
-	    export LIBGCC2_DEBUG_CFLAGS="-g -Zhigh-mem -Zaout"; \
-		export       CFLAGS="$(OMFSPEC_HACK) -Zhigh-mem -Zomf -g "; \
-		export     CXXFLAGS="$(OMFSPEC_HACK) -Zhigh-mem -Zomf -g "; \
-		export  BOOT_CFLAGS="$(OMFSPEC_HACK) -Zhigh-mem -Zomf -g "; \
-		export      LDFLAGS="$(OMFSPEC_HACK) -Zhigh-mem -Zomf -g -Zcrtdll -Zstack 1024"; \
-		export BOOT_LDFLAGS="$(OMFSPEC_HACK) -Zhigh-mem -Zomf -g -Zcrtdll -Zstack 1024"; \
-		$(subst \,/,$(COMSPEC)) ; \
-		mv -f $(PATH_BUILTTOOLS)/omfhackbin $(PATH_BUILTTOOLS)/omfhack
-	
-
-# When changed directory
-#   We pass down alot of flags here, but currently we don't use half of them as
-#   we're not booting the compiler.
-
-#OMFSPEC_HACK = $(if $(wildchar $(PATH_OBJ)/.all-stage1),\
-#               -specs $(PATH_TOP)/src/emx/src/lib/libc.specs, \
-#               -specs $(PATH_TOP)/tools/x86.os2/gcc/staged/lib/gcc-lib/i386-pc-os2-emx/$(GCC_VERSION)/specs)
-OMFSPECS_HACK =
-gccomf-build-it: \
-		$(PATH_OBJ)/gccomf/.ts.configured
-ifeq "$(BUILD_PLATFORM)" "OS2"		
-	if test -d $(PATH_BUILTTOOLS)/omfhack; then mv -f $(PATH_BUILTTOOLS)/omfhack $(PATH_BUILTTOOLS)/omfhackbin; fi
-	if test ! -d $(PATH_BUILTTOOLS)/omfhackbin; then echo "no omfhackbin"; exit 1; fi ; \
-	unset GCCLOAD ; export GCC_OMF="real" ; echo GCC_OMF=$$GCC_OMF; $(MAKE) $(MAKEOPT) -C $(PATH_OBJ)/gccomf \
-	    LIBGCC2_DEBUG_CFLAGS="-g -Zhigh-mem -Zaout" \
-		      CFLAGS="$(OMFSPEC_HACK) -Zhigh-mem -Zomf -g " \
-		    CXXFLAGS="$(OMFSPEC_HACK) -Zhigh-mem -Zomf -g " \
-		 BOOT_CFLAGS="$(OMFSPEC_HACK) -Zhigh-mem -Zomf -g " \
-		     LDFLAGS="$(OMFSPEC_HACK) -Zhigh-mem -Zomf -g -Zcrtdll -Zstack 1024" \
-		BOOT_LDFLAGS="$(OMFSPEC_HACK) -Zhigh-mem -Zomf -g -Zcrtdll -Zstack 1024" \
-		-e all
-	mv -f $(PATH_BUILTTOOLS)/omfhackbin $(PATH_BUILTTOOLS)/omfhack
-else
-	$(MAKE) $(MAKEOPT) -C $(PATH_OBJ)/gcc all
-endif	
-
-	
-# configure it (invoked after directory change).
-# 	We set CC to help configure finding it.
-gccomf-configure-it $(PATH_OBJ)/gccomf/.ts.configured: $(PATH_TOP)/src/gcc/configure
-ifeq "$(BUILD_PLATFORM)" "OS2"
-	$(ASH) -c " \
-		export CC=\"gcc.exe\" ; \
-		$< \
-		--enable-clh \
-		--enable-threads=os2 \
-		--enable-shared=libgcc,bfd,opcodes \
-		--disable-nls \
-		--without-included-gettext \
-		--with-local-prefix=$(subst \,/,$(PATH_EMXPGCC)) \
-		--prefix=/gcc \
-		--with-gnu-ld \
-		--with-gnu-as \
-		--disable-libgcj \
-		--enable-languages=c,c++ "
-else
-	$(ASH) -c "$< \
-		--disable-clh \
-		--enable-shared=libgcc,bfd,opcodes \
-		--disable-nls \
-		--without-included-gettext \
-		--with-local-prefix=$(subst \,/,$(PATH_EMXPGCC)) \
-		--prefix=/gcc \
-		--with-gnu-ld \
-		--with-gnu-as \
-		--disable-libgcj \
-		--enable-languages=c,c++ "
-endif
-	touch $(PATH_OBJ)/gccomf/.ts.configured
-# TODO: Andy, on Linux --enable-clh result in linking errors.
-
-# Install the GCC build
-#	Repeating the prefix doesn't hurt anybody.
-gccomf-install-it:
-	$(MAKE) $(MAKEOPT) prefix=$(ALL_PREFIX) install
 
 
@@ -958,5 +973,5 @@
 	echo "Separate building of binutils is not configured."
 
-all-binutils214 binutils214:	\
+binutils214:	\
         binutils-autoconf-refresh \
         binutils-build
@@ -1077,4 +1092,12 @@
 	
 
+# Quick bootstrap workers.
+binutils-quick: binutils214
+
+binutils-quick-installstage:
+	rm -Rf $(PATH_BUILTTOOLS_TMP)
+	$(MAKE) $(MAKEOPT) -C $(PATH_OBJ)/binutils prefix=$(PATH_BUILTTOOLS_TMPD) install
+	cp -Rf $(PATH_BUILTTOOLS_TMP)/* $(PATH_BUILTTOOLS)/
+
 					
 # Generate diffs for Binutils (part of packing).
@@ -1155,6 +1178,20 @@
 
 
-# Generate diffs for Binutils (part of packing).
-.PHONY: binutils-diff $(ALL_PREFIX)/src/diffs/emx-$(EMX_VERSION).diff
+# Quick bootstrap workers.			
+emx-quick-libs:
+	$(MAKE) $(MAKEOPT) -f $(PATH_TOP)/src/emx/libonly.gmk -C $(PATH_TOP)/src/emx $(EMX_DEFINES) all
+
+emx-quick-libs-install:
+	$(MAKE) $(MAKEOPT) -f $(PATH_TOP)/src/emx/libonly.gmk -C $(PATH_TOP)/src/emx $(EMX_DEFINES) INS=$(PATH_BUILTTOOLS)/ install
+					
+emx-quick-rest:
+	$(MAKE) $(MAKEOPT) -C $(PATH_TOP)/src/emx $(EMX_DEFINES) all
+			
+emx-quick-rest-install:
+	$(MAKE) $(MAKEOPT) -C $(PATH_TOP)/src/emx $(EMX_DEFINES) INS=$(PATH_BUILTTOOLS)/ install
+			    	
+
+# Generate diffs for EMX (part of packing).
+.PHONY: emx-diff $(ALL_PREFIX)/src/diffs/emx-$(EMX_VERSION).diff
 emx-diff: $(ALL_PREFIX)/src/diffs/emx-$(EMX_VERSION).diff
 $(ALL_PREFIX)/src/diffs/emx-$(EMX_VERSION).diff: