Index: trunk/kBuild/tools/VCC70.kmk
===================================================================
--- trunk/kBuild/tools/VCC70.kmk	(revision 1119)
+++ trunk/kBuild/tools/VCC70.kmk	(revision 1129)
@@ -136,5 +136,6 @@
 #endef
 #else # !USE_KOBJCACHE
-TOOL_VCC70_COMPILE_C_OUTPUT = $(call TOOL_VCC70_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC70_PDB, $(outbase)-obj,idb)
+TOOL_VCC70_COMPILE_C_OUTPUT = $(call TOOL_VCC70_PDB, $(outbase)-obj,idb)
+TOOL_VCC70_COMPILE_C_OUTPUT_MAYBE = $(call TOOL_VCC70_PDB, $(outbase)-obj,pdb)
 define TOOL_VCC70_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_VCC70_CC) -c\
@@ -183,5 +184,6 @@
 #endef
 #else # !USE_KOBJCACHE
-TOOL_VCC70_COMPILE_CXX_OUTPUT = $(call TOOL_VCC70_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC70_PDB, $(outbase)-obj,idb)
+TOOL_VCC70_COMPILE_CXX_OUTPUT = $(call TOOL_VCC70_PDB, $(outbase)-obj,idb)
+TOOL_VCC70_COMPILE_CXX_OUTPUT_MAYBE = $(call TOOL_VCC70_PDB, $(outbase)-obj,pdb)
 define TOOL_VCC70_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_VCC70_CXX) -c\
Index: trunk/kBuild/tools/VCC80.kmk
===================================================================
--- trunk/kBuild/tools/VCC80.kmk	(revision 1119)
+++ trunk/kBuild/tools/VCC80.kmk	(revision 1129)
@@ -144,5 +144,6 @@
 TOOL_VCC80_COMPILE_C_DEPEND =
 TOOL_VCC80_COMPILE_C_DEPORD =
-TOOL_VCC80_COMPILE_C_OUTPUT = $(call TOOL_VCC80_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80_PDB, $(outbase)-obj,idb)
+TOOL_VCC80_COMPILE_C_OUTPUT = $(call TOOL_VCC80_PDB, $(outbase)-obj,idb)
+TOOL_VCC80_COMPILE_C_OUTPUT_MAYBE = $(call TOOL_VCC80_PDB, $(outbase)-obj,pdb)
 define TOOL_VCC80_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_VCC80_CC) -c\
@@ -171,5 +172,6 @@
 TOOL_VCC80_COMPILE_CXX_DEPEND =
 TOOL_VCC80_COMPILE_CXX_DEPORD =
-TOOL_VCC80_COMPILE_CXX_OUTPUT = $(call TOOL_VCC80_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80_PDB, $(outbase)-obj,idb)
+TOOL_VCC80_COMPILE_CXX_OUTPUT = $(call TOOL_VCC80_PDB, $(outbase)-obj,idb)
+TOOL_VCC80_COMPILE_CXX_OUTPUT_MAYBE = $(call TOOL_VCC80_PDB, $(outbase)-obj,pdb)
 define TOOL_VCC80_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_VCC80_CXX) -c\
Index: trunk/kBuild/tools/VCC80AMD64.kmk
===================================================================
--- trunk/kBuild/tools/VCC80AMD64.kmk	(revision 1119)
+++ trunk/kBuild/tools/VCC80AMD64.kmk	(revision 1129)
@@ -123,5 +123,6 @@
 TOOL_VCC80AMD64_COMPILE_C_DEPEND =
 TOOL_VCC80AMD64_COMPILE_C_DEPORD =
-TOOL_VCC80AMD64_COMPILE_C_OUTPUT = $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,idb)
+TOOL_VCC80AMD64_COMPILE_C_OUTPUT = $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,idb)
+TOOL_VCC80AMD64_COMPILE_C_OUTPUT_MAYBE = $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,pdb)
 define TOOL_VCC80AMD64_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_VCC80AMD64_CC) -c\
@@ -150,5 +151,6 @@
 TOOL_VCC80AMD64_COMPILE_CXX_DEPEND =
 TOOL_VCC80AMD64_COMPILE_CXX_DEPORD =
-TOOL_VCC80AMD64_COMPILE_CXX_OUTPUT = $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,idb)
+TOOL_VCC80AMD64_COMPILE_CXX_OUTPUT = $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,idb)
+TOOL_VCC80AMD64_COMPILE_CXX_OUTPUT_MAYBE = $(call TOOL_VCC80AMD64_PDB, $(outbase)-obj,pdb)
 define TOOL_VCC80AMD64_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_VCC80AMD64_CXX) -c\
Index: trunk/kBuild/tools/VCC80X86.kmk
===================================================================
--- trunk/kBuild/tools/VCC80X86.kmk	(revision 1119)
+++ trunk/kBuild/tools/VCC80X86.kmk	(revision 1129)
@@ -124,5 +124,6 @@
 TOOL_VCC80X86_COMPILE_C_DEPEND =
 TOOL_VCC80X86_COMPILE_C_DEPORD =
-TOOL_VCC80X86_COMPILE_C_OUTPUT = $(call TOOL_VCC80X86_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80X86_PDB, $(outbase)-obj,idb)
+TOOL_VCC80X86_COMPILE_C_OUTPUT = $(call TOOL_VCC80X86_PDB, $(outbase)-obj,idb)
+TOOL_VCC80X86_COMPILE_C_OUTPUT_MAYBE = $(call TOOL_VCC80X86_PDB, $(outbase)-obj,pdb)
 define TOOL_VCC80X86_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_VCC80X86_CC) -c\
@@ -151,5 +152,6 @@
 TOOL_VCC80X86_COMPILE_CXX_DEPEND =
 TOOL_VCC80X86_COMPILE_CXX_DEPORD =
-TOOL_VCC80X86_COMPILE_CXX_OUTPUT = $(call TOOL_VCC80X86_PDB, $(outbase)-obj,pdb) $(call TOOL_VCC80X86_PDB, $(outbase)-obj,idb)
+TOOL_VCC80X86_COMPILE_CXX_OUTPUT = $(call TOOL_VCC80X86_PDB, $(outbase)-obj,idb)
+TOOL_VCC80X86_COMPILE_CXX_OUTPUT_MAYBE = $(call TOOL_VCC80X86_PDB, $(outbase)-obj,pdb)
 define TOOL_VCC80X86_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_VCC80X86_CXX) -c\